diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-configuration.cc ns-3.45/src/wifi/model/eht/eht-configuration.cc
--- ns-3.44/src/wifi/model/eht/eht-configuration.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-configuration.cc	2025-06-01 20:34:45.613702300 -0700
@@ -11,6 +11,7 @@
 
 #include "ns3/attribute-container.h"
 #include "ns3/boolean.h"
+#include "ns3/double.h"
 #include "ns3/enum.h"
 #include "ns3/integer.h"
 #include "ns3/log.h"
@@ -162,7 +163,12 @@
                         MakeAttributeContainerChecker<UintegerValue>(
                             MakeUintegerChecker<uint8_t>()),
                         MakeAttributeContainerChecker<UintegerValue>(
-                            MakeUintegerChecker<uint8_t>()))));
+                            MakeUintegerChecker<uint8_t>()))))
+            .AddAttribute("Per20CcaSensitivityThreshold",
+                          "CCA threshold (dBm) for Per 20MHz check.",
+                          DoubleValue(-72.0),
+                          MakeDoubleAccessor(&EhtConfiguration::m_per20CcaSensitivityThreshold),
+                          MakeDoubleChecker<dBm_u>());
     return tid;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-configuration.h ns-3.45/src/wifi/model/eht/eht-configuration.h
--- ns-3.44/src/wifi/model/eht/eht-configuration.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-configuration.h	2025-06-01 20:34:45.613702300 -0700
@@ -110,7 +110,8 @@
     std::map<std::list<uint64_t>, std::list<uint64_t>>
         m_linkMappingDl; //!< TIDs-indexed Link Mapping for downlink
     std::map<std::list<uint64_t>, std::list<uint64_t>>
-        m_linkMappingUl; //!< TIDs-indexed Link Mapping for uplink
+        m_linkMappingUl;                 //!< TIDs-indexed Link Mapping for uplink
+    dB_u m_per20CcaSensitivityThreshold; //!< CCA threshold for Per 20MHz check
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-frame-exchange-manager.cc ns-3.45/src/wifi/model/eht/eht-frame-exchange-manager.cc
--- ns-3.44/src/wifi/model/eht/eht-frame-exchange-manager.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-frame-exchange-manager.cc	2025-06-01 20:34:45.614702200 -0700
@@ -30,8 +30,6 @@
 namespace ns3
 {
 
-const Time EMLSR_RX_PHY_START_DELAY = MicroSeconds(20);
-
 /**
  * Additional time (exceeding 20 us) to wait for a PHY-RXSTART.indication when the PHY is
  * decoding a PHY header.
@@ -111,7 +109,9 @@
     NS_LOG_FUNCTION(this << *mpdu);
 
     // alias needs only be created for non-broadcast QoS data frames exchanged between two MLDs
-    if (!mpdu->GetHeader().IsQosData() || m_mac->GetNLinks() == 1 ||
+    if (auto staMac = DynamicCast<StaWifiMac>(m_mac);
+        !mpdu->GetHeader().IsQosData() ||
+        (staMac ? (staMac->GetAssocType() == WifiAssocType::LEGACY) : (m_mac->GetNLinks() == 1)) ||
         mpdu->GetHeader().GetAddr1().IsGroup() ||
         !GetWifiRemoteStationManager()->GetMldAddress(mpdu->GetHeader().GetAddr1()))
     {
@@ -155,13 +155,9 @@
     {
         return false;
     }
-    auto apAddress = GetWifiRemoteStationManager()->GetMldAddress(m_bssid);
-    NS_ASSERT_MSG(apAddress, "MLD address not found for BSSID " << m_bssid);
-    // when EMLSR links are blocked, all TIDs are blocked (we test TID 0 here)
-    WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *apAddress, 0);
-    auto mask = m_staMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, m_linkId);
-    NS_ASSERT_MSG(mask, "No mask for AP " << *apAddress << " on link " << m_linkId);
-    return mask->test(static_cast<std::size_t>(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK));
+    return m_staMac->GetMacQueueScheduler()->GetAllQueuesBlockedOnLink(
+        m_linkId,
+        WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
 }
 
 bool
@@ -410,18 +406,7 @@
     {
         NS_ASSERT(m_staMac->GetEmlsrManager());
         m_staMac->GetEmlsrManager()->NotifyInDeviceInterferenceStart(m_linkId, txDuration);
-
-        for (const auto linkId : m_staMac->GetLinkIds())
-        {
-            if (auto phy = m_mac->GetWifiPhy(linkId);
-                phy && linkId != m_linkId && m_staMac->IsEmlsrLink(linkId))
-            {
-                const auto txPower = phy->GetPower(txVector.GetTxPowerLevel()) + phy->GetTxGain();
-                // generate in-device interference on the other EMLSR link for the duration of this
-                // transmission
-                GenerateInDeviceInterference(linkId, txDuration, DbmToW(txPower));
-            }
-        }
+        GenerateInDeviceInterferenceForAll(txDuration, txVector);
     }
 }
 
@@ -499,47 +484,73 @@
     {
         NS_ASSERT(m_staMac->GetEmlsrManager());
         m_staMac->GetEmlsrManager()->NotifyInDeviceInterferenceStart(m_linkId, txDuration);
+        GenerateInDeviceInterferenceForAll(txDuration, txVector);
+    }
+}
 
-        for (const auto linkId : m_staMac->GetLinkIds())
+void
+EhtFrameExchangeManager::GenerateInDeviceInterferenceForAll(const Time& txDuration,
+                                                            const WifiTxVector& txVector)
+{
+    NS_LOG_FUNCTION(this << txDuration.As(Time::MS) << txVector);
+
+    NS_ASSERT(m_staMac);
+    NS_ASSERT(m_staMac->GetEmlsrManager());
+
+    for (const auto& phy : m_staMac->GetDevice()->GetPhys())
+    {
+        // generate in-device interference for a PHY provided that:
+        // - the PHY is not the one the client is using to transmit
+        // - either the PHY is not operating on any link or it is operating on an EMLSR link
+        // Interference is generated for the duration of this transmission
+        if (auto id = m_staMac->GetLinkForPhy(phy);
+            phy != m_phy && (!id || m_staMac->IsEmlsrLink(*id)))
         {
-            if (auto phy = m_mac->GetWifiPhy(linkId);
-                phy && linkId != m_linkId && m_staMac->IsEmlsrLink(linkId))
-            {
-                const auto txPower = phy->GetPower(txVector.GetTxPowerLevel()) + phy->GetTxGain();
-                // generate in-device interference on the other EMLSR link for the duration of this
-                // transmission
-                GenerateInDeviceInterference(linkId, txDuration, DbmToW(txPower));
-            }
+            const auto txPower = phy->GetPower(txVector.GetTxPowerLevel()) + phy->GetTxGain();
+            GenerateInDeviceInterference(phy, txDuration, DbmToW(txPower));
         }
     }
 }
 
 void
-EhtFrameExchangeManager::GenerateInDeviceInterference(uint8_t linkId, Time duration, Watt_u txPower)
+EhtFrameExchangeManager::GenerateInDeviceInterference(Ptr<WifiPhy> phy,
+                                                      Time duration,
+                                                      Watt_u txPower)
 {
-    NS_LOG_FUNCTION(this << linkId << duration.As(Time::US) << txPower);
+    NS_LOG_FUNCTION(this << phy << duration.As(Time::US) << txPower);
 
-    auto rxPhy = DynamicCast<SpectrumWifiPhy>(m_mac->GetWifiPhy(linkId));
+    auto rxPhy = DynamicCast<SpectrumWifiPhy>(phy);
 
     if (!rxPhy)
     {
-        NS_LOG_DEBUG("No spectrum PHY operating on link " << +linkId);
+        NS_LOG_DEBUG("No spectrum PHY");
         return;
     }
 
     auto txPhy = DynamicCast<SpectrumWifiPhy>(m_phy);
     NS_ASSERT(txPhy);
 
-    auto psd = Create<SpectrumValue>(rxPhy->GetCurrentInterface()->GetRxSpectrumModel());
-    *psd = txPower;
+    for (const auto& [range, interface] : rxPhy->GetSpectrumPhyInterfaces())
+    {
+        if (!interface->GetRxSpectrumModel())
+        {
+            // we may have created a PHY interface but never set a frequency channel comprised
+            // in the frequency range associated with that PHY interface, thus the RX spectrum
+            // model may have not been created
+            continue;
+        }
 
-    auto spectrumSignalParams = Create<SpectrumSignalParameters>();
-    spectrumSignalParams->duration = duration;
-    spectrumSignalParams->txPhy = txPhy->GetCurrentInterface();
-    spectrumSignalParams->txAntenna = txPhy->GetAntenna();
-    spectrumSignalParams->psd = psd;
+        auto psd = Create<SpectrumValue>(interface->GetRxSpectrumModel());
+        *psd = txPower;
 
-    rxPhy->StartRx(spectrumSignalParams, rxPhy->GetCurrentInterface());
+        auto spectrumSignalParams = Create<SpectrumSignalParameters>();
+        spectrumSignalParams->duration = duration;
+        spectrumSignalParams->txPhy = txPhy->GetCurrentInterface();
+        spectrumSignalParams->txAntenna = txPhy->GetAntenna();
+        spectrumSignalParams->psd = psd;
+
+        rxPhy->StartRx(spectrumSignalParams, interface);
+    }
 }
 
 void
@@ -567,9 +578,9 @@
 }
 
 bool
-EhtFrameExchangeManager::UnblockEmlsrLinksIfAllowed(Mac48Address address)
+EhtFrameExchangeManager::UnblockEmlsrLinksIfAllowed(Mac48Address address, bool checkThisLink)
 {
-    NS_LOG_FUNCTION(this << address);
+    NS_LOG_FUNCTION(this << address << checkThisLink);
 
     auto mldAddress = GetWifiRemoteStationManager()->GetMldAddress(address);
     NS_ASSERT_MSG(mldAddress, "MLD address not found for " << address);
@@ -621,9 +632,8 @@
             return false;
         }
 
-        if (linkId == m_linkId)
+        if (linkId == m_linkId && !checkThisLink)
         {
-            // no need to check if the EMLSR client is involved in a DL TXOP on this link
             continue;
         }
 
@@ -657,8 +667,8 @@
     NS_ASSERT_MSG(mldAddress, "MLD address not found for " << address);
     NS_ASSERT_MSG(m_apMac, "This function shall only be called by AP MLDs");
 
-    auto blockLinks = [=, this]() {
-        if (!UnblockEmlsrLinksIfAllowed(address))
+    auto blockLinks = [=, this](bool checkThisLink) {
+        if (!UnblockEmlsrLinksIfAllowed(address, checkThisLink))
         {
             NS_LOG_DEBUG("Could not unblock transmissions to " << address);
             return;
@@ -696,7 +706,16 @@
                                                   Simulator::Schedule(endDelay, unblockLinks));
     };
 
-    delay.IsZero() ? blockLinks() : static_cast<void>(Simulator::Schedule(delay, blockLinks));
+    // it makes sense to check if the EMLSR client is involved in a DL TXOP on this link only if
+    // the transition delay start is scheduled to start after some delay, because the AP MLD may
+    // start another DL TXOP in the meantime. An example is when the AP MLD terminates a TXOP on
+    // this link due to the remaining TXOP time being not enough to send another frame (not even a
+    // CF-End), delays the start of the transition delay to align with the EMLSR client (which is
+    // waiting for a SIFS + slot + PHY RXSTART delay after the last frame to switch to listening
+    // operations), gains channel access on this link again before starting the transition delay
+    // timer and sends an ICF.
+    delay.IsZero() ? blockLinks(false)
+                   : static_cast<void>(Simulator::Schedule(delay, [=]() { blockLinks(true); }));
 }
 
 void
@@ -909,8 +928,8 @@
         {
             // EMLSR client switched to listening operations if it was protected, otherwise
             // simply unblock transmissions
-            m_protectedStas.contains(address) ? EmlsrSwitchToListening(address, Seconds(0))
-                                              : (void)(UnblockEmlsrLinksIfAllowed(address));
+            m_protectedStas.contains(address) ? EmlsrSwitchToListening(address, Time{0})
+                                              : (void)(UnblockEmlsrLinksIfAllowed(address, false));
             m_protectedStas.erase(address);
         }
     }
@@ -941,6 +960,23 @@
     return HeFrameExchangeManager::GetUpdateCwOnCtsTimeout();
 }
 
+bool
+EhtFrameExchangeManager::GetReportRtsFailed() const
+{
+    NS_LOG_FUNCTION(this);
+
+    if (m_apMac)
+    {
+        if (const auto apEmlsrManager = m_apMac->GetApEmlsrManager();
+            apEmlsrManager && IsCrossLinkCollision(m_sentRtsTo))
+        {
+            return apEmlsrManager->ReportFailedIcf();
+        }
+    }
+
+    return HeFrameExchangeManager::GetReportRtsFailed();
+}
+
 void
 EhtFrameExchangeManager::TbPpduTimeout(WifiPsduMap* psduMap, std::size_t nSolicitedStations)
 {
@@ -1037,8 +1073,12 @@
                             on the given link ID */
                          [=, this](uint8_t id) {
                              auto macHdr = m_mac->GetFrameExchangeManager(id)->GetReceivedMacHdr();
-                             return macHdr.has_value() &&
-                                    m_mac->GetMldAddress(macHdr->get().GetAddr2()) == mldAddress;
+                             if (!macHdr.has_value())
+                             {
+                                 return false;
+                             }
+                             auto addr2 = macHdr->get().GetAddr2();
+                             return m_mac->GetMldAddress(addr2) == mldAddress;
                          }))
         {
             crossLinkCollision = false;
@@ -1050,18 +1090,20 @@
 
 void
 EhtFrameExchangeManager::SendCtsAfterRts(const WifiMacHeader& rtsHdr,
-                                         WifiMode rtsTxMode,
+                                         const WifiTxVector& rtsTxVector,
                                          double rtsSnr)
 {
-    NS_LOG_FUNCTION(this << rtsHdr << rtsTxMode << rtsSnr);
+    NS_LOG_FUNCTION(this << rtsHdr << rtsTxVector << rtsSnr);
+
+    auto addr2 = rtsHdr.GetAddr2();
 
-    if (m_apMac && GetWifiRemoteStationManager()->GetEmlsrEnabled(rtsHdr.GetAddr2()))
+    if (m_apMac && GetWifiRemoteStationManager()->GetEmlsrEnabled(addr2))
     {
         // we are going to send a CTS to an EMLSR client, transmissions to such EMLSR client
         // must be blocked on the other EMLSR links
 
-        auto mldAddress = GetWifiRemoteStationManager()->GetMldAddress(rtsHdr.GetAddr2());
-        NS_ASSERT_MSG(mldAddress, "MLD address not found for " << rtsHdr.GetAddr2());
+        auto mldAddress = GetWifiRemoteStationManager()->GetMldAddress(addr2);
+        NS_ASSERT_MSG(mldAddress, "MLD address not found for " << addr2);
 
         for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); ++linkId)
         {
@@ -1089,7 +1131,7 @@
         }
     }
 
-    HeFrameExchangeManager::SendCtsAfterRts(rtsHdr, rtsTxMode, rtsSnr);
+    HeFrameExchangeManager::SendCtsAfterRts(rtsHdr, rtsTxVector, rtsSnr);
 }
 
 bool
@@ -1197,13 +1239,21 @@
 
     if (m_apMac)
     {
-        // the channel has been released; all EMLSR clients are switching back to
-        // listening operation
+        // the channel has been released; if the TXNAV is still set, it means that there is not
+        // enough time left to send a CF-End. In this case, EMLSR clients wait for a slot plus the
+        // PHY RX start delay before switching back to listening operation (in this case, this
+        // function is called a SIFS after the last frame in the TXOP)
+        Time delay{0};
+        if (const auto remTxNav = m_txNav - Simulator::Now(); remTxNav.IsStrictlyPositive())
+        {
+            delay = Min(m_phy->GetSlot() + EMLSR_RX_PHY_START_DELAY, remTxNav);
+        }
+
         for (const auto& address : m_protectedStas)
         {
             if (GetWifiRemoteStationManager()->GetEmlsrEnabled(address))
             {
-                EmlsrSwitchToListening(address, Seconds(0));
+                EmlsrSwitchToListening(address, delay);
             }
         }
     }
@@ -1212,12 +1262,9 @@
         // Notify the UL TXOP end to the EMLSR Manager
         auto edca = DynamicCast<QosTxop>(txop);
         NS_ASSERT(edca);
-        auto txopStart = edca->GetTxopStartTime(m_linkId);
 
         NS_ASSERT(m_staMac->GetEmlsrManager());
-        m_staMac->GetEmlsrManager()->NotifyTxopEnd(m_linkId,
-                                                   (!txopStart || *txopStart == Simulator::Now()),
-                                                   m_ongoingTxopEnd.IsPending());
+        m_staMac->GetEmlsrManager()->NotifyTxopEnd(m_linkId, edca);
     }
 
     HeFrameExchangeManager::NotifyChannelReleased(txop);
@@ -1287,7 +1334,9 @@
     if (m_apMac && m_txopHolder == psdu->GetAddr2() &&
         GetWifiRemoteStationManager()->GetEmlsrEnabled(*m_txopHolder))
     {
-        if (!m_ongoingTxopEnd.IsPending())
+        const auto unrespondedRts = (psdu->GetHeader(0).IsRts() && !m_sendCtsEvent.IsPending());
+
+        if (!m_ongoingTxopEnd.IsPending() && !unrespondedRts)
         {
             // an EMLSR client has started an UL TXOP. Start the ongoingTxopEnd timer so that
             // the next call to UpdateTxopEndOnRxEnd does its job
@@ -1312,11 +1361,19 @@
         }
     }
 
-    if (m_staMac && m_icfReceived)
+    if (m_staMac && m_dlTxopStart)
     {
+        // we just got involved in a DL TXOP. Check if we are still involved in the TXOP in a
+        // SIFS (we are expected to reply in a SIFS)
+        m_ongoingTxopEnd.Cancel();
+        NS_LOG_DEBUG("Expected TXOP end=" << (Simulator::Now() + m_phy->GetSifs()).As(Time::S));
+        m_ongoingTxopEnd = Simulator::Schedule(m_phy->GetSifs() + TimeStep(1),
+                                               &EhtFrameExchangeManager::TxopEnd,
+                                               this,
+                                               psdu->GetAddr2());
         // notify the EMLSR manager
-        m_staMac->GetEmlsrManager()->NotifyIcfReceived(m_linkId);
-        m_icfReceived = false;
+        m_staMac->GetEmlsrManager()->NotifyDlTxopStart(m_linkId);
+        m_dlTxopStart = false;
     }
 }
 
@@ -1424,7 +1481,7 @@
     NS_ASSERT(mpdu->GetHeader().GetAddr1().IsGroup() || mpdu->GetHeader().GetAddr1() == m_self);
 
     const auto& hdr = mpdu->GetHeader();
-    const auto sender = hdr.GetAddr2();
+    auto sender = hdr.GetAddr2();
 
     if (hdr.IsTrigger())
     {
@@ -1453,23 +1510,18 @@
                 return;
             }
 
-            auto emlsrManager = m_staMac->GetEmlsrManager();
-            NS_ASSERT(emlsrManager);
-
-            m_icfReceived = true;
-
-            // we just got involved in a DL TXOP. Check if we are still involved in the TXOP in a
-            // SIFS (we are expected to reply by sending a CTS frame)
-            m_ongoingTxopEnd.Cancel();
-            NS_LOG_DEBUG("Expected TXOP end=" << (Simulator::Now() + m_phy->GetSifs()).As(Time::S));
-            m_ongoingTxopEnd = Simulator::Schedule(m_phy->GetSifs() + NanoSeconds(1),
-                                                   &EhtFrameExchangeManager::TxopEnd,
-                                                   this,
-                                                   sender);
+            m_dlTxopStart = true;
         }
     }
+    else if (m_staMac && m_staMac->IsEmlsrLink(m_linkId) && !m_ongoingTxopEnd.IsPending() &&
+             m_phy->GetPhyId() == m_staMac->GetEmlsrManager()->GetMainPhyId() &&
+             (hdr.IsRts() || hdr.IsBlockAckReq() || (hdr.IsData() && hdr.GetAddr1() == m_self)))
+    {
+        // a frame that is starting a DL TXOP has been received by the main PHY
+        m_dlTxopStart = true;
+    }
 
-    if (!m_icfReceived && ShallDropReceivedMpdu(mpdu))
+    if (!m_dlTxopStart && ShallDropReceivedMpdu(mpdu))
     {
         NS_LOG_DEBUG("Drop received MPDU: " << *mpdu);
         return;
@@ -1502,7 +1554,16 @@
         this << *psdu << rxSignalInfo << txVector << perMpduStatus.size()
              << std::all_of(perMpduStatus.begin(), perMpduStatus.end(), [](bool v) { return v; }));
 
-    if (ShallDropReceivedMpdu(*psdu->begin()))
+    const auto& hdr = psdu->GetHeader(0);
+    if (m_staMac && m_staMac->IsEmlsrLink(m_linkId) && !m_ongoingTxopEnd.IsPending() &&
+        m_phy->GetPhyId() == m_staMac->GetEmlsrManager()->GetMainPhyId() &&
+        (hdr.IsData() && hdr.GetAddr1() == m_self))
+    {
+        // a frame that is starting a DL TXOP has been received by the main PHY
+        m_dlTxopStart = true;
+    }
+
+    if (!m_dlTxopStart && ShallDropReceivedMpdu(*psdu->begin()))
     {
         return;
     }
@@ -1521,6 +1582,25 @@
         return false;
     }
 
+    // discard any frame received after scheduling a CTS response. It has been observed that
+    // an ICF may be received by both the main PHY and an aux PHY (leading to scheduling a
+    // CTS response twice) if:
+    // - the main PHY switches to an aux PHY link and completes the switch during the preamble
+    //   detection period for a PPDU (that is not an ICF), hence main PHY connection is postponed
+    // - right afterwards, an ICF is transmitted on the aux PHY link (collision with the other
+    //   PPDU)
+    // - the main PHY starts receiving the ICF, and so does the aux PHY because the ICF signal
+    //   is stronger
+    // - at the end of the ICF reception, the aux PHY notifies the ICF to the FEM, which schedules
+    //   a CTS and connects the main PHY to the link; then, the main PHY notifies the ICF to the
+    //   FEM again
+    if (m_sendCtsEvent.IsPending())
+    {
+        NS_LOG_DEBUG("Dropping " << *mpdu << " received when CTS is scheduled for TX on link "
+                                 << +m_linkId);
+        return true;
+    }
+
     const auto& hdr = mpdu->GetHeader();
 
     // We impose that an aux PHY is only able to receive an ICF, a CF-End, a CTS or a management
@@ -1604,7 +1684,7 @@
             // started before the reception of the ICF ended. We drop this ICF and let the
             // UL TXOP continue.
             NS_LOG_DEBUG("Drop ICF because another EMLSR link is being used");
-            m_icfDropCallback(WifiIcfDrop::USING_OTHER_LINK, m_linkId);
+            m_icfDropCallback({WifiIcfDrop::USING_OTHER_LINK, m_linkId, m_bssid});
             return true;
         }
     }
@@ -1631,30 +1711,14 @@
     else if (auto mainPhy = m_staMac->GetDevice()->GetPhy(emlsrManager->GetMainPhyId());
              mainPhy != m_phy)
     {
-        const auto delay = mainPhy->GetChannelSwitchDelay();
-        auto lastTime = mainPhy->GetState()->GetLastTime({WifiPhyState::TX});
-        auto reason = WifiIcfDrop::NOT_ENOUGH_TIME_TX;
-
-        if (auto lastSwitch = mainPhy->GetState()->GetLastTime({WifiPhyState::SWITCHING});
-            lastSwitch > lastTime)
-        {
-            lastTime = lastSwitch;
-            reason = WifiIcfDrop::NOT_ENOUGH_TIME_SWITCH;
-        }
-        if (auto lastSleep = mainPhy->GetState()->GetLastTime({WifiPhyState::SLEEP});
-            lastSleep > lastTime)
-        {
-            lastTime = lastSleep;
-            reason = WifiIcfDrop::NOT_ENOUGH_TIME_SLEEP;
-        }
-        // ignore RX state for now
+        auto reason = emlsrManager->CheckMainPhyTakesOverDlTxop(m_linkId);
 
-        if (lastTime > Simulator::Now() - delay)
+        if (reason.has_value())
         {
             NS_LOG_DEBUG(
                 "Drop ICF due to not enough time for the main PHY to switch link; reason = "
-                << reason);
-            m_icfDropCallback(reason, m_linkId);
+                << *reason);
+            m_icfDropCallback({*reason, m_linkId, m_bssid});
             return true;
         }
     }
@@ -1726,6 +1790,8 @@
         // after the end of this PPDU, hence we need to postpone the TXOP end in order to
         // get the PHY-RXSTART.indication
         delay = txDuration + m_phy->GetSifs() + m_phy->GetSlot() + EMLSR_RX_PHY_START_DELAY;
+        // TXOP end cannot be beyond the period protected via Duration/ID
+        delay = Min(delay, txDuration + durationId);
     }
 
     NS_LOG_DEBUG("Expected TXOP end=" << (Simulator::Now() + delay).As(Time::S));
@@ -1779,6 +1845,8 @@
     // we may send a response after a SIFS or we may receive another frame after a SIFS.
     // Postpone the TXOP end by considering the latter (which takes longer)
     auto delay = m_phy->GetSifs() + m_phy->GetSlot() + EMLSR_RX_PHY_START_DELAY;
+    // TXOP end cannot be beyond the period protected via Duration/ID
+    delay = Min(delay, durationId);
     NS_LOG_DEBUG("Expected TXOP end=" << (Simulator::Now() + delay).As(Time::S));
     m_ongoingTxopEnd =
         Simulator::Schedule(delay, &EhtFrameExchangeManager::TxopEnd, this, m_txopHolder);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-frame-exchange-manager.h ns-3.45/src/wifi/model/eht/eht-frame-exchange-manager.h
--- ns-3.44/src/wifi/model/eht/eht-frame-exchange-manager.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-frame-exchange-manager.h	2025-06-01 20:34:45.614702200 -0700
@@ -17,10 +17,6 @@
 namespace ns3
 {
 
-/// aRxPHYStartDelay value to use when waiting for a new frame in the context of EMLSR operations
-/// (Sec. 35.3.17 of 802.11be D3.1)
-extern const Time EMLSR_RX_PHY_START_DELAY;
-
 class MgtEmlOmn;
 
 /**
@@ -171,7 +167,7 @@
     void SetIcfPaddingAndTxVector(CtrlTriggerHeader& trigger, WifiTxVector& txVector) const;
 
     /// ICF drop reason traced callback (WifiMac exposes this trace source)
-    TracedCallback<WifiIcfDrop, uint8_t> m_icfDropCallback;
+    WifiMac::IcfDropTracedCallback m_icfDropCallback;
 
   protected:
     void DoDispose() override;
@@ -180,6 +176,7 @@
     void ForwardPsduMapDown(WifiConstPsduMap psduMap, WifiTxVector& txVector) override;
     void CtsAfterMuRtsTimeout(Ptr<WifiMpdu> muRts, const WifiTxVector& txVector) override;
     bool GetUpdateCwOnCtsTimeout() const override;
+    bool GetReportRtsFailed() const override;
     void SendCtsAfterMuRts(const WifiMacHeader& muRtsHdr,
                            const CtrlTriggerHeader& trigger,
                            double muRtsSnr) override;
@@ -198,7 +195,9 @@
                          const std::vector<bool>& perMpduStatus) override;
     void NavResetTimeout() override;
     void IntraBssNavResetTimeout() override;
-    void SendCtsAfterRts(const WifiMacHeader& rtsHdr, WifiMode rtsTxMode, double rtsSnr) override;
+    void SendCtsAfterRts(const WifiMacHeader& rtsHdr,
+                         const WifiTxVector& rtsTxVector,
+                         double rtsSnr) override;
     void PsduRxError(Ptr<const WifiPsdu> psdu) override;
     void ReceivedQosNullAfterBsrpTf(Mac48Address sender) override;
     void SendQosNullFramesInTbPpdu(const CtrlTriggerHeader& trigger,
@@ -242,9 +241,11 @@
      * is not involved in any DL or UL TXOP on another link.
      *
      * @param address the link MAC address of the given EMLSR client
+     * @param checkThisLink whether to check if the EMLSR client is involved in a DL TXOP on
+     *                      this link
      * @return whether transmissions could be unblocked
      */
-    bool UnblockEmlsrLinksIfAllowed(Mac48Address address);
+    bool UnblockEmlsrLinksIfAllowed(Mac48Address address, bool checkThisLink);
 
   private:
     /**
@@ -263,14 +264,23 @@
     void SwitchToListeningOrUnblockLinks(const std::set<Mac48Address>& clients);
 
     /**
-     * Generate an in-device interference of the given power on the given link for the given
-     * duration.
+     * Generate an in-device interference of the given power for the given duration for the given
+     * PHY.
      *
-     * @param linkId the ID of the link on which in-device interference is generated
+     * @param phy the PHY for which in-device interference is generated
      * @param duration the duration of the in-device interference
      * @param txPower the TX power
      */
-    void GenerateInDeviceInterference(uint8_t linkId, Time duration, Watt_u txPower);
+    void GenerateInDeviceInterference(Ptr<WifiPhy> phy, Time duration, Watt_u txPower);
+
+    /**
+     * Generate in-device interference caused by a transmission on this link for all the other PHYs
+     * of this EMLSR client.
+     *
+     * @param txDuration the duration of the transmission
+     * @param txVector the TXVECTOR used to transmit the frame
+     */
+    void GenerateInDeviceInterferenceForAll(const Time& txDuration, const WifiTxVector& txVector);
 
     /**
      * Update the TXOP end timer when starting a frame transmission.
@@ -301,8 +311,8 @@
      */
     void TxopEnd(const std::optional<Mac48Address>& txopHolder);
 
-    bool m_icfReceived{false}; //!< whether an ICF has been received and needs to be notified to
-                               //!< the EMLSR manager after post-processing the frame
+    bool m_dlTxopStart{false}; //!< whether a DL TXOP start is detected and needs to be notified to
+                               //!< the EMLSR manager after post-processing the initial frame
     EventId m_ongoingTxopEnd;  //!< event indicating the possible end of the current TXOP (of which
                                //!< we are not the holder)
     std::unordered_map<Mac48Address, EventId, WifiAddressHash>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-operation.cc ns-3.45/src/wifi/model/eht/eht-operation.cc
--- ns-3.44/src/wifi/model/eht/eht-operation.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-operation.cc	2025-06-01 20:34:45.614702200 -0700
@@ -18,28 +18,12 @@
 void
 EhtOperation::Print(std::ostream& os) const
 {
-    os << "EHT Operation=" << +m_params.opInfoPresent << "|" << +m_params.disabledSubchBmPresent
-       << "|" << +m_params.defaultPeDur << "|" << +m_params.grpBuIndLimit << "|"
-       << +m_params.grpBuExp << "|[";
-    for (const auto& maxRxNss : m_mcsNssSet.maxRxNss)
-    {
-        os << +maxRxNss << "|";
-    }
-    os << "]|[";
-    for (const auto& maxTxNss : m_mcsNssSet.maxTxNss)
-    {
-        os << +maxTxNss << "|";
-    }
-    os << "]";
+    os << "EHT Operation=[";
     if (m_opInfo.has_value())
     {
-        os << "|" << +m_opInfo->control.channelWidth << "|" << +m_opInfo->ccfs0 << "|"
-           << +m_opInfo->ccfs1;
-        if (m_opInfo->disabledSubchBm.has_value())
-        {
-            os << "|" << m_opInfo->disabledSubchBm.value();
-        }
+        os << "Channel Width: " << +m_opInfo->control.channelWidth;
     }
+    os << "]";
 }
 
 void
